SystemOrganization addCategory: #BackgammonController!

SimpleSwitchMorph subclass: #InputButton
	instanceVariableNames: 'mouseAction playerTurn p1Name p2Name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

!InputButton commentStamp: 'jChizmar 7/9/2015 07:56' prior: 0!
A button that responds to input!

!InputButton class methodsFor: 'initialize' stamp: 'AhmedSoliman 7/23/2015 13:18'!
text: labelText boardHeight: boardHeight

	| buttonWidth buttonHeight |
	buttonWidth := 70.
	buttonHeight := 50.
	
	
	super initialize.
^ ((self new) 	labelString: labelText; 
					minWidth: buttonWidth; 
					extent: buttonWidth@buttonHeight;
					left: 10;
					top: (boardHeight / 2) - (buttonHeight / 2);
					playerTurn: 1
	).! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 14:14'!
initialize
	super initialize.
	p1Name := 'Player 1'.
	p2Name := 'Player 2'! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 20:50'!
mouseAction: t1
	^ mouseAction := t1! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 20:54'!
mouseUp: t1
	mouseAction value.
	^ self! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/23/2015 13:19'!
playerTurn
	^playerTurn ! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/23/2015 13:19'!
playerTurn: aTurn
	playerTurn := aTurn! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 14:05'!
rollDie: myBoardModel
	| rollCommand |
	p1Name := myBoardModel  player1 nameOfPlayer.
	p2Name := myBoardModel  player2 nameOfPlayer.
	rollCommand := (RollCommand new) dice1: (myBoardModel dice1) dice2: (myBoardModel dice2).
	rollCommand execute.
	
	Transcript show: (rollCommand dice1 currentRoll).
	Transcript show: (rollCommand dice2 currentRoll);cr.! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 14:18'!
step
	
	| temp |
	super step.
	
	playerTurn = 1
		ifTrue: [ temp:= p1Name, '''s Turn'. self label: temp ]
		ifFalse: [ temp:= p2Name, '''s Turn'. self label: temp ]! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:54'!
toggleChecker: aChecker onBoard: myBoardModel
	| myMoveCommand prevLocation |
	
	prevLocation := ((aChecker checkerLocation) pointNumber).
	
	prevLocation = 2
	ifTrue: [ 
		myMoveCommand := MoveCheckerCommand new checker: aChecker location: (myBoardModel points at:12).	
		 ]
	ifFalse: [ 
		myMoveCommand := MoveCheckerCommand new checker: aChecker location: (myBoardModel points at:2 ).	
		 ].
	
	myMoveCommand execute.! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/23/2015 13:24'!
toggleTurn
	"Toggle "
	playerTurn = 1
		ifTrue: [ self playerTurn: 2 ]
		ifFalse: [ self playerTurn: 1 ]! !

Object subclass: #BackgammonStart
	instanceVariableNames: 'myBoardModel myBoardView observables diceView1 diceView2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

!BackgammonStart commentStamp: 'DavidOvergaard 7/16/2015 21:27' prior: 0!
Initialize and run backgammon game!

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:27'!
start
	^BackgammonStart new start.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 14:17'!
displayBoardDice
	| boardHeight boardWidth |
	boardHeight := myBoardView getBoardSize y.	"Add the dice to the board"
	boardWidth := myBoardView getBoardSize x.
	diceView1 := DieView dieModel: myBoardModel dice1.
	myBoardView addMorph: (diceView1 dieMorph
		left: boardWidth / 2 - 50 - 50;
		top: boardHeight / 2 - 15).
	diceView2 := DieView dieModel: myBoardModel dice2.
	myBoardView addMorph: (diceView2 dieMorph
		left: boardWidth / 2 + 50 - 50;
		top: boardHeight / 2 - 15)! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:01'!
model
	^myBoardModel.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:23'!
observable: anObject
	observables add: anObject.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:16'!
observables
	^observables! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 13:59'!
promptForPlayersNames
	"Ask each player in turn about their name and update the model"
	"Prompt for player 1"
	| player1Name player2Name |
	player1Name := UIManager default request: 'Player 1 name:' initialAnswer: 'Ahmed'.
	myBoardModel player1 nameOfPlayer: player1Name.
	
	"Prompt for player 2"
	player2Name := UIManager default request: 'Player 2 name:' initialAnswer: 'Bob'.
	myBoardModel player2 nameOfPlayer: player2Name.
	
	"myBoardView displayNameForPlayer1: player1Name  Player2: player2Name"  ! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 14:19'!
start
	| diceButton |
	myBoardModel := MainBoard initialize.
	myBoardView := BackgammonBoard createNewBoard: self.
	observables := OrderedCollection new.
	myBoardModel player1Checkers
		do: [ :aChecker | 
			myBoardView addCheckerAtPoint: aChecker checkerLocation pointNumber color: aChecker color.
			aChecker addObserver: myBoardView lastAddedChecker ].
	myBoardModel player2Checkers
		do: [ :aChecker | 
			myBoardView addCheckerAtPoint: aChecker checkerLocation pointNumber color: aChecker color.
			aChecker addObserver: myBoardView lastAddedChecker ].	"Test move with observer"
	self promptForPlayersNames .
	diceButton := InputButton text: 'Roll dice' boardHeight: myBoardView getBoardSize y.
	diceButton mouseAction: [ diceButton rollDie: myBoardModel. diceButton toggleTurn ].
	myBoardView addMorph: diceButton.	"self promptForPlayersNames ."	"Add the dice to the board"
	self displayBoardDice.
	myBoardView drawBearOffChecker1With: (myBoardModel player1BOChecker).
	myBoardView drawBearOffChecker2With: (myBoardModel player2BOChecker).
	myBoardModel offLocationP1 addObserver: (myBoardModel player1BOChecker).
	myBoardModel offLocationP2 addObserver: (myBoardModel player2BOChecker).! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'xl 7/24/2015 00:39'!
updatedBearOffCheckerCount
	self model offLocationP1 incrementNumCheckersOnHome! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/24/2015 22:31'!
updatedBearOffCheckerCountByColor:aColor
| modelChecker moveCheckerCommand playerOff   |
	(aColor = (self model player1 checkerColor))
			ifTrue: [ 
				"self model offLocationP1 incrementNumCheckersOnHome"
				
				playerOff := self model offLocationP1.
			 ]
			ifFalse: [ 
				"self model offLocationP2 incrementNumCheckersOnHome"
				playerOff := self model offLocationP2.
			 ].
	modelChecker :=  self aChecker observable.
	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: playerOff.
	Halt now.
	moveCheckerCommand execute.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/24/2015 22:37'!
updatedBearOffCheckerCountByColor:aColor checker:aChecker
| modelChecker moveCheckerCommand playerOff   |
	(aColor = (self model player1 checkerColor))
			ifTrue: [ 
				"self model offLocationP1 incrementNumCheckersOnHome"
				
				playerOff := self model offLocationP1.
			 ]
			ifFalse: [ 
				"self model offLocationP2 incrementNumCheckersOnHome"
				playerOff := self model offLocationP2.
			 ].
	modelChecker :=  aChecker.
	
	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: playerOff.

	moveCheckerCommand execute.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/24/2015 22:22'!
updatedChecker: aChecker toPointNum: pointNum
	| modelChecker moveCheckerCommand |
"	Transcript show: (aChecker location)."
	modelChecker := aChecker observable.
	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel points at: pointNum).
	Halt now.
	moveCheckerCommand execute.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:02'!
view
	^myBoardView := BackgammonBoard createNewBoard.! !
